#include <imsls.h>

int main() {
    static float x[40][7] = {
        1.0,    0.0,    7.0,   64.0,    5.0,  411.0,    0.0, 
        1.0,    0.0,    6.0,   63.0,    9.0,  126.0,    0.0,
        1.0,    0.0,    7.0,   65.0,   11.0,  118.0,    0.0,
        1.0,    0.0,    4.0,   69.0,   10.0,   92.0,    0.0,
        1.0,    0.0,    4.0,   63.0,   58.0,    8.0,    0.0,
        1.0,    0.0,    7.0,   48.0,    9.0,   25.0,    1.0,
        1.0,    0.0,    7.0,   48.0,   11.0,   11.0,    0.0,
        2.0,    0.0,    8.0,   63.0,    4.0,   54.0,    0.0,
        2.0,    0.0,    6.0,   63.0,   14.0,  153.0,    0.0,
        2.0,    0.0,    3.0,   53.0,    4.0,   16.0,    0.0,
        2.0,    0.0,    8.0,   43.0,   12.0,   56.0,    0.0,
        2.0,    0.0,    4.0,   55.0,    2.0,   21.0,    0.0,
        2.0,    0.0,    6.0,   66.0,   25.0,  287.0,    0.0,
        2.0,    0.0,    4.0,   67.0,   23.0,   10.0,    0.0,
        3.0,    0.0,    2.0,   61.0,   19.0,    8.0,    0.0,
        3.0,    0.0,    5.0,   63.0,    4.0,   12.0,    0.0,
        4.0,    0.0,    5.0,   66.0,   16.0,  177.0,    0.0,
        4.0,    0.0,    4.0,   68.0,   12.0,   12.0,    0.0,
        4.0,    0.0,    8.0,   41.0,   12.0,  200.0,    0.0,
        4.0,    0.0,    7.0,   53.0,    8.0,  250.0,    0.0,
        4.0,    0.0,    6.0,   37.0,   13.0,  100.0,    0.0,
        1.0,    1.0,    9.0,   54.0,   12.0,  999.0,    0.0,
        1.0,    1.0,    5.0,   52.0,    8.0,  231.0,    1.0,
        1.0,    1.0,    7.0,   50.0,    7.0,  991.0,    0.0,
        1.0,    1.0,    2.0,   65.0,   21.0,    1.0,    0.0,
        1.0,    1.0,    8.0,   52.0,   28.0,  201.0,    0.0,
        1.0,    1.0,    6.0,   70.0,   13.0,   44.0,    0.0,
        1.0,    1.0,    5.0,   40.0,   13.0,   15.0,    0.0,
        2.0,    1.0,    7.0,   36.0,   22.0,  103.0,    1.0,
        2.0,    1.0,    4.0,   44.0,   36.0,    2.0,    0.0,
        2.0,    1.0,    3.0,   54.0,    9.0,   20.0,    0.0,
        2.0,    1.0,    3.0,   59.0,   87.0,   51.0,    0.0,
        3.0,    1.0,    4.0,   69.0,    5.0,   18.0,    0.0,
        3.0,    1.0,    6.0,   50.0,   22.0,   90.0,    0.0,
        3.0,    1.0,    8.0,   62.0,    4.0,   84.0,    0.0,
        4.0,    1.0,    7.0,   68.0,   15.0,  164.0,    0.0,
        4.0,    1.0,    3.0,   39.0,    4.0,   19.0,    0.0,
        4.0,    1.0,    6.0,   49.0,   11.0,   43.0,    0.0,
        4.0,    1.0,    8.0,   64.0,   10.0,  340.0,    0.0,
        4.0,    1.0,    7.0,   67.0,   18.0,  231.0,    0.0};
    int   n_observations = 40;
    int   n_class = 2;
    int   n_continuous = 3;
    int   model = 0;
    int   n_coef;
    int   icen = 6, ilt = -1, irt = 5;
    int   lp_max = 40;
    int   n, *ncv, nrmiss, *obs;
    float *iterations, *cv, criterion;
    float *coef_stat, *casex;
    char *fmt = "%12.4f";
    char *fmt2 = "%4d%4d%6.4f%8.4f%8.1f";
    static char *clabels[] = {"", "coefficient", "s.e.", "z", "p"};
    static char *clabels2[] = {"", "Method", "Iteration", "Step Size",
        "Coef Update", "Log-Likelihood"};

    n_coef = imsls_f_survival_glm(n_observations, n_class, 
        n_continuous, model, &x[0][0], 
        IMSLS_X_COL_CENSORING, icen, ilt, irt, 
        IMSLS_INFINITY_CHECK, lp_max,
        IMSLS_COEF_STAT, &coef_stat,
        IMSLS_ITERATIONS, &n, &iterations, 
        IMSLS_CASE_ANALYSIS, &casex,
        IMSLS_CLASS_INFO, &ncv, &cv, 
        IMSLS_OBS_STATUS, &obs, 
        IMSLS_CRITERION, &criterion,
        IMSLS_N_ROWS_MISSING, &nrmiss, 
        0); 

    imsls_f_write_matrix("Coefficient Statistics", n_coef, 4, 
        coef_stat, 
        IMSLS_WRITE_FORMAT, fmt, 
        IMSLS_NO_ROW_LABELS,
        IMSLS_COL_LABELS, clabels,
        0);

    imsls_f_write_matrix("Iteration Information", n, 5, iterations,
        IMSLS_WRITE_FORMAT, fmt2, 
        IMSLS_NO_ROW_LABELS,
        IMSLS_COL_LABELS, clabels2, 0);

    printf("\nLog-Likelihood = %12.5f\n", criterion);

    imsls_f_write_matrix("Case Analysis", 1, n_observations, casex, 
        IMSLS_WRITE_FORMAT, fmt, 
        0);

    imsls_f_write_matrix(
        "Distinct Values for Classification Variable 1",
        1, ncv[0], &cv[0], IMSLS_NO_COL_LABELS, 0);

    imsls_f_write_matrix(
        "Distinct Values for Classification Variable 2",
        1, ncv[1], &cv[ncv[0]], IMSLS_NO_COL_LABELS, 0);

    imsls_i_write_matrix("Observation Status", 1, n_observations, 
        obs, 0); 

    printf("\nNumber of Missing Values = %2d\n", nrmiss);
}
